# -*- coding: UTF-8 -*-
import re
import json


def get_tags():
    return ['1', '1.2']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''grep -v "^[[:space:]]*#" /etc/login.defs | grep PASS_MAX_DAYS'''
    tmp_vars["systemvalue1"] = ""

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = '''grep -v "^[[:space:]]*#" /etc/login.defs | grep PASS_MIN_DAYS'''
    tmp_vars["systemvalue2"] = ""

    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = '''grep -v ^[[:space:]]*# /etc/login.defs | grep PASS_WARN_AGE'''
    tmp_vars["systemvalue3"] = ""

    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = r'''excepuserlist=`grep -v root /etc/passwd | grep -v '^\s*#' | awk -F':' '($7 == "/bin/false" || $7 == "/sbin/nologin") {print $1}'`;matchlist=`grep -v root  /etc/shadow | grep -v '^\s*#' | egrep ^[^:]+:[^\!*x] 2>/dev/null | awk -F':' '(($4 != 10 || $5 < 10 || $5 > 90 || $6 != 7)&&($2!~/^[*!x]/)&&($2!~/^$/)) {print $1}'`;for match in $matchlist;do flag='false';for excepuser in $excepuserlist;do if [ $excepuser == $match ]; then flag='true';fi;done;if [ $flag == 'false' ]; then echo $match;fi;done;unset excepuserlist;unset matchlist;unset flag '''
    tmp_vars["systemvalue4"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand3"])
    arc3, astdout3, astderr3 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc3, astdout3, astderr3)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand4"])
    arc4, astdout4, astderr4 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc4, astdout4, astderr4)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1 = re.match(r"^\s*PASS_MAX_DAYS\s+(90\s*$|[1-8][0-9]\s*$)", astdout1)
    tmp_vars["systemvalue1"] = astdout1
    if match1:
        tmp_vars["checkresult1"] = "pass"

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s." % astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2 = re.match(r"^\s*PASS_MIN_DAYS\s+([7-9]|[1-8][0-9])\s*$", astdout2)
    tmp_vars["systemvalue2"] = astdout2
    if match2:
        tmp_vars["checkresult2"] = "pass"

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s." % astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3 = re.match(r"^\s*PASS_WARN_AGE\s+[7-9]|[1-9][0-9]|[1-9][0-9][0-9]\s*$", astdout3)
    tmp_vars["systemvalue3"] = astdout3
    if match3:
        tmp_vars["checkresult3"] = "pass"

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s." % astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4 = re.match(r"^\s*$", astdout4)

    tmp_vars["systemvalue4"] = astdout4
    if match4:
        tmp_vars["checkresult4"] = "pass"

    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult3"] == "pass" and tmp_vars["checkresult4"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_1_2.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
